#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

long long n;
long long a[1000001],b[1000001];
long long p[1000001];

void read()
{
    cin>>n;
    for(long long i=1;i<=n;i++)
        cin>>a[i]>>b[i];

    for(long long i=1;i<=n;i++)
        cin>>p[i];
}

long long dp[5001][5001];
void solve()
{
    dp[1][0]=a[1];
    long long ans=max(1LL*0,a[1]);
    for(long long i=2;i<=n;i++)
    {
        for(long long j=0;j<i;j++)
        {
            dp[i][j]=-1e18;
            for(long long jj=0;jj<min(j+1,i-1);jj++)
                dp[i][j]=max(dp[i][j],dp[i-1][jj]+a[i]+b[i]*j);

            ans=max(ans,dp[i][j]);
        }
    }

    cout<<ans<<endl;
}

int main()
{
    speed();
    read();
    solve();
    return 0;
}
